#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

//#define DEBUG

#include <gtk/gtk.h>

#include "cssedwindow.h"
#include "document.h"
#include "support.h"

void 
parser_css_selector_buffer_to_list(gchar* buffer, Tcssed_window* window, Tcssed_doc* doc)
{
	GtkListStore* output;
	GtkListStore* current;
	GtkTreeIter iter;
	gchar** property_and_value;
	gchar** tokens;
	gint index = 0;	

	output  = (GtkListStore*) window->output_store;
	current = (GtkListStore*) window->css_store;
	
	// cleanup the store
	gtk_list_store_clear(current);
	
	// TODO: 	check if have comment and strip out 
	// 			check if any pair don't end in ";" ( the last can do it )
	// 			check if property is in css definition file (treeview)
	//			check if there are more than one ":" in a pair but out of a string
	tokens = g_strsplit(buffer,";",-1);
	
	while( tokens[index] != NULL ){	
		g_strstrip(tokens[index]);
		gtk_list_store_insert (current, &iter,index);
		
		property_and_value = g_strsplit(tokens[index],":",2);
		if( (property_and_value[0] != NULL) && (property_and_value[1] != NULL) ){					
			gtk_list_store_set (current, &iter,0, property_and_value[0],-1);
			gtk_list_store_set (current, &iter,1, property_and_value[1],-1);
#ifdef DEBUG
			g_print("Property - %s\n",property_and_value[0]);
			g_print("Value - %s\n",property_and_value[1]);
#endif
		}		
		g_strfreev(property_and_value);
		index++;				
	}			
	
	g_strfreev (tokens);
	if(buffer) g_free(buffer);
}
