/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

//#define DEBUG

#include <gtk/gtk.h>
#include "cssedwindow.h"
#include "interface.h"
#include "support.h"
#include "document.h"

/* show an error message - this must change to addere to the HIG             
  http://developer.gnome.org/projects/gup/hig/1.0/windows.html#alert-windows*/
void
cssed_error_message (gchar * message, gchar * title)
{
	GtkWidget* error_box; 
	GtkWidget* label;
	GtkWidget* label_detail;
	
	gchar* error_message;
	
	error_box = create_error_dialog ();	
	gtk_window_set_title ((GtkWindow *) error_box, "");
	
	label = lookup_widget (error_box, "label_msg");
	label_detail = lookup_widget (error_box, "label_detail");
	
	error_message = g_strdup_printf("<span weight=\"bold\" size=\"larger\">%s</span>", title);
	gtk_label_set_text (GTK_LABEL(label), error_message);
	gtk_label_set_use_markup(GTK_LABEL(label),TRUE);
	gtk_label_set_text (GTK_LABEL(label_detail), message);
	gtk_widget_show_all(error_box);
	
	g_free(error_message);
}

/* Converts a GdkColor to a triplet #RRGGBB string 
   the returned string must be freed by caller  */
gchar*
gdk_color_to_rgb_triplet_string( GdkColor* color)
{
	gchar* rgb;
	float r;
	float g;
	float b;

	r=color->red;
	g=color->green;
	b=color->blue;
	
	r=(r/65535)*255;
	g=(g/65535)*255;
	b=(b/65535)*255;
	
#ifdef DEBUG
	g_print("gdk_color_to_rgb_triplet_string\n\tColor : r(%d) g(%d) b(%d)\n",r,g,b);	
#endif
	
	rgb = g_strdup_printf("#%02x%02x%02x",(int) r,(int) g,(int) b);
	return rgb;
}
/*  I did this for the bluefish project http://bluefish.openoffice.nl 
	It's unused, but I'm sure I will use it */
GtkWidget*
create_custom_button_from_stock(gchar* label_text,gchar *stock_id)
{
  GtkWidget* button;
  GtkWidget* image;
  GtkWidget* box;
  GtkWidget* label;

  button = gtk_button_new();
  box = gtk_hbox_new(FALSE,0);

  image = gtk_image_new_from_stock(stock_id,GTK_ICON_SIZE_BUTTON);
  label = gtk_label_new(label_text);

  gtk_box_pack_start((GtkBox*)box,image,FALSE,FALSE,0);
  gtk_box_pack_end  ((GtkBox*)box,label,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(image);
  gtk_widget_show(box);
  gtk_container_add(GTK_CONTAINER(button),box);

  return button;
}
